%option noyywrap
%option yylineno
%{
    /*
    * You will need to comment this line in lab5.
    */
    #define ONLY_FOR_LEX
    
    #ifdef ONLY_FOR_LEX
    #else
    #define YYSTYPE void *
    #include "parser.h"
    #endif

    #define YY_NO_UNPUT
    #define YY_NO_INPUT
    #include <string>


    #ifdef ONLY_FOR_LEX
    #include <ostream>
    #include <fstream>
    using namespace std;

    extern FILE *yyin; 
    extern FILE *yyout;

    void DEBUG_FOR_LAB4(std::string s){
        std::string DEBUG_INFO = s + "\t" + std::to_string(yylineno)  + "\n";
        fputs(DEBUG_INFO.c_str(), yyout);
    }

    void DEBUG_FOR_LAB4(std::string s,char* t){
        std::string DEBUG_INFO =  s + "\t" + t + "\t" + std::to_string(yylineno) + "\n";
        fputs(DEBUG_INFO.c_str(), yyout);
    }
    void DEBUG_FOR_LAB4_NUM(std::string s,int a){
        std::string DEBUG_INFO =  s + "\t" + std::to_string(a) + "\t" + std::to_string(yylineno) + "\n";
        fputs(DEBUG_INFO.c_str(), yyout);
    }

    void DEBUG_FOR_LAB4_ID(std::string s){
        std::string DEBUG_INFO = "ID\t" + s + "\t" + std::to_string(yylineno)  + "\n";
        fputs(DEBUG_INFO.c_str(), yyout);

    }

    //八进制转十进制
    int HtoD(char*s)
    {
        char *str=new char[yyleng+1];
        strcpy(str,s);
        strcat(str,"\0");
        int i = 0;
        sscanf(str, "%x", &i);
        printf("%d\n", i);
        return i;
    }

    int OtoD(char*s)
    {
        char *str=new char[yyleng+1];
        strcpy(str,s);
        strcat(str,"\0");
        int i = 0;
        sscanf(str, "%o", &i);
        printf("%d\n", i);
        return i;
    }


    #endif
%}

blockcommentBegin "/*"
blockcommentElement .|\n
blockcommentEnd "*/"
%x BLOCKCOMMENT

LINECOMMENT \/\/[^\n]*

HEXADECIMAL ("0x"|"0X")([1-9a-fA-F][0-9a-fA-F]*|0)
OCTAL (0+)[1-7][0-7]*
DECIMAL ([1-9][0-9]*|0)
ID [[:alpha:]_][[:alpha:][:digit:]_]*

EOL (\r\n|\n|\r)
WHITE [\t ]



%%
{blockcommentBegin} {BEGIN BLOCKCOMMENT;fprintf(yyout,"Begin a comment:\n");}
<BLOCKCOMMENT>{blockcommentElement} {fprintf(yyout,"%s",yytext);}
<BLOCKCOMMENT>{blockcommentEnd} {BEGIN INITIAL;fprintf(yyout,"\nthis comment end\n");}

{LINECOMMENT}

"int" {
    /*
    * Questions:
    *   Q1: Why we need to return INT in further labs?
    *   Q2: What is "INT" actually?
    */
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("INT\tint");
    #else
        return INT;
    #endif
}
"void" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("VOID\tvoid");
    #else
        return VOID;
    #endif 
}
"while" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("WHILE\twhile");
    #else
        return WHILE;
    #endif
}
"if" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("IF\tif");
    #else
        return IF;
    #endif
};
"else" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("ELSE\telse");
    #else
        return ELSE;
    #endif
};
"for" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("FOR\tvoid");
    #else
        return FOR;
    #endif 
}
"break" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("BREAK\tvoid");
    #else
        return BREAK;
    #endif 
}
"continue" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("CONTUNUE\tcontinue");
    #else
        return CONTINUE;
    #endif 
}
"return" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("RETURN\treturn");
    #else
        return RETURN;
    #endif
}//保留字


"=" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("ASIGN\t=");
    #else
        return ASIGN;
    #endif
}
"+" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("ADD\t+");
    #else
        return ADD;
    #endif
}
"-" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("SUB\t-");
    #else
        return SUB;
    #endif
}
"*" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("MUL\t*");
    #else
        return MUL;
    #endif
}
"/" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("DIV\t/");
    #else
        return DIV;
    #endif
}
"%" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("MOD\t%");
    #else
        return MOD;
    #endif
}//算术运算符

 
"==" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("HEQ\t==");
    #else
        return HEQ;
    #endif
}
"<" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LESS\t<");
    #else
        return LESS;
    #endif
}
">" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LAGER\t>");
    #else
        return LAGER;
    #endif
}
"<=" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LESSEQ\t<=");
    #else
        return LESSEQ;
    #endif
}
">=" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LAGERQU\t>=");
    #else
        return LAGERQU;
    #endif
}
"<>" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("NOTEQ\t<>");
    #else
        return NOTEQ;
    #endif
}


"&&" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("AND\t&&");
    #else
        return AND;
    #endif
}
"||" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("OR\t||");
    #else
        return OR;
    #endif
}
"!" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("NOT\t!");
    #else
        return NOT;
    #endif
}

"," {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("COMMA\t;");
    #else
        return COMMA;
    #endif
}
";" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("SEMICOLON\t;");
    #else
        return SEMICOLON;
    #endif
}
"(" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LPAREN\t(");
    #else
        return LPAREN;
    #endif
}
")" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("RPAREN\t)");
    #else
        return RPAREN;
    #endif
}
"{" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("LBRACE\t{");
    #else
        return LBRACE;
    #endif
}
"}" {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("RBRACE\t}");
    #else
        return RBRACE;
    #endif
}

{DECIMAL} {
    #ifdef ONLY_FOR_LEX
        DEBUG_FOR_LAB4("DECIMIAL",yytext);
    #else
        return DECIMAL;
    #endif
}

{OCTAL} {
    #ifdef ONLY_FOR_LEX
        int tmp=OtoD(yytext);
        DEBUG_FOR_LAB4_NUM("OCTAL",tmp);
    #else
        return OCTAL;
    #endif
}
{HEXADECIMAL} {
    #ifdef ONLY_FOR_LEX
        int tmp=HtoD(yytext);
        DEBUG_FOR_LAB4_NUM("HEXADECIMAL",tmp);
    #else
        return HEXADECIMAL;
    #endif
}


{ID} {
    #ifdef ONLY_FOR_LEX
        char*cisu=new char[yyleng+1];
        strcpy(cisu,yytext);
        strcat(cisu,"\0");
        DEBUG_FOR_LAB4_ID(cisu);
    #else
        return ID;
    #endif
}

{EOL} //已自动加

{WHITE}

%%

#ifdef ONLY_FOR_LEX
int main(int argc, char** argv) {
    if (argc != 5) {
        fprintf(stderr, "Argument Not Enough");
        exit(EXIT_FAILURE);
    }

    if (!(yyin = fopen(argv[1], "r"))) {
        fprintf(stderr, "No such file or directory: %s", argv[1]);
        exit(EXIT_FAILURE);
    }

    if (!(yyout = fopen(argv[3], "w"))) {
        fprintf(stderr, "No such file or directory: %s", argv[3]);
        exit(EXIT_FAILURE);
    }
    yylex();
    fclose(yyin);
    fclose(yyout);
    return 0;
}
#endif
